package org.xbib.event.async.yield.async;

import org.xbib.event.async.yield.AsyncQuery;

import java.util.concurrent.CompletableFuture;
import java.util.function.BiConsumer;
import java.util.function.Function;

public class AsyncQueryMap<T, R> extends AsyncQuery<R> {

    private final AsyncQuery<T> upstream;

    private final Function<? super T, ? extends R> mapper;

    public AsyncQueryMap(AsyncQuery<T> upstream, Function<? super T, ? extends R> mapper) {
        this.upstream = upstream;
        this.mapper = mapper;
    }

    @Override
    public CompletableFuture<Void> subscribe(BiConsumer<? super R, ? super Throwable> cons) {
        return upstream.subscribe((item, err) -> {
            if (err != null) {
                cons.accept(null, err);
                return;
            }
            cons.accept(mapper.apply(item), null);
        });
    }
}
