package org.xbib.event.async.yield.async;

import org.xbib.event.async.yield.AsyncQuery;

import java.util.Iterator;
import java.util.concurrent.CompletableFuture;
import java.util.function.BiConsumer;

public class AsyncQueryOfIterator<T> extends AsyncQuery<T> {

    private final Iterator<T> iter;

    public AsyncQueryOfIterator(Iterator<T> iter) {
        this.iter = iter;
    }

    @Override
    public CompletableFuture<Void> subscribe(BiConsumer<? super T, ? super Throwable> cons) {
        while (iter.hasNext()) {
            cons.accept(iter.next(), null);
        }
        return CompletableFuture.completedFuture(null);
    }
}
