package org.xbib.event.async.yield.ops;

import org.xbib.event.async.yield.Advancer;
import org.xbib.event.async.yield.Traverser;
import org.xbib.event.async.yield.Yield;

import java.util.function.UnaryOperator;

public class Iterate<U> implements Advancer<U>, Traverser<U> {

    private final UnaryOperator<U> f;

    private U prev;

    public Iterate(U seed, UnaryOperator<U> f) {
        this.f = f;
        this.prev = seed;
    }

    @Override
    public void traverse(Yield<? super U> yield) {
        for (U curr = prev; true; curr = f.apply(curr))
            yield.ret(curr);
    }

    @Override
    public boolean tryAdvance(Yield<? super U> yield) {
        U curr = prev;
        prev = f.apply(prev);
        yield.ret(curr);
        return true;
    }
}
