package org.xbib.event.async.yield.primitives.dbl.ops;

import org.xbib.event.async.yield.primitives.dbl.DoubleAdvancer;
import org.xbib.event.async.yield.primitives.dbl.DoubleQuery;
import org.xbib.event.async.yield.primitives.dbl.DoubleTraverser;
import org.xbib.event.async.yield.primitives.dbl.DoubleYield;

public class DoubleConcat implements DoubleAdvancer, DoubleTraverser {

    private final DoubleQuery first;

    private final DoubleQuery second;

    public DoubleConcat(DoubleQuery first, DoubleQuery second) {
        this.first = first;
        this.second = second;
    }

    @Override
    public void traverse(DoubleYield yield) {
        this.first.traverse(yield);
        this.second.traverse(yield);
    }

    @Override
    public boolean tryAdvance(DoubleYield yield) {
        return first.tryAdvance(yield) || second.tryAdvance(yield);
    }
}
