package org.xbib.event.async.yield.primitives.dbl.ops;

import org.xbib.event.async.yield.primitives.dbl.DoubleAdvancer;
import org.xbib.event.async.yield.primitives.dbl.DoubleQuery;
import org.xbib.event.async.yield.primitives.dbl.DoubleTraverser;
import org.xbib.event.async.yield.primitives.dbl.DoubleYield;

public class DoubleSkip implements DoubleAdvancer, DoubleTraverser {

    private final DoubleQuery upstream;

    private final int n;
    int index;

    public DoubleSkip(DoubleQuery adv, int n) {
        this.upstream = adv;
        this.n = n;
        index = 0;
    }

    /**
     * Continues from the point where tryAdvance or next left the
     * internal iteration.
     *
     * @param yield yield
     */
    @Override
    public void traverse(DoubleYield yield) {
        upstream.traverse(item -> {
            if (index++ >= n) {
                yield.ret(item);
            }
        });
    }

    @Override
    public boolean tryAdvance(DoubleYield yield) {
        for (; index < n; index++)
            upstream.tryAdvance(item -> {
            });
        return upstream.tryAdvance(yield);
    }
}
