package org.xbib.event.async.yield.primitives.intgr.ops;

import org.xbib.event.async.yield.primitives.intgr.IntAdvancer;
import org.xbib.event.async.yield.primitives.intgr.IntQuery;
import org.xbib.event.async.yield.primitives.intgr.IntTraverser;
import org.xbib.event.async.yield.primitives.intgr.IntYield;

import java.util.function.IntFunction;

public class IntFlatMap implements IntAdvancer, IntTraverser {
    private final IntQuery upstream;
    private final IntFunction<? extends IntQuery> mapper;
    IntQuery src;

    public IntFlatMap(IntQuery query, IntFunction<? extends IntQuery> mapper) {
        this.upstream = query;
        this.mapper = mapper;
        src = new IntQuery(IntAdvancer.empty(), IntTraverser.empty());
    }

    @Override
    public void traverse(IntYield yield) {
        upstream.traverse(elem -> mapper.apply(elem).traverse(yield));
    }

    @Override
    public boolean tryAdvance(IntYield yield) {
        while (!src.tryAdvance(yield)) {
            if (!upstream.tryAdvance(t -> src = mapper.apply(t)))
                return false;
        }
        return true;
    }
}
