package org.xbib.event.async.yield.primitives.intgr.ops;

import org.xbib.event.async.yield.primitives.intgr.IntAdvancer;
import org.xbib.event.async.yield.primitives.intgr.IntTraverser;
import org.xbib.event.async.yield.primitives.intgr.IntYield;

import java.util.function.IntUnaryOperator;

public class IntIterate implements IntAdvancer, IntTraverser {
    private final IntUnaryOperator f;
    private int prev;

    public IntIterate(int seed, IntUnaryOperator f) {
        this.f = f;
        this.prev = seed;
    }

    /**
     * Continues from the point where tryAdvance or next left the
     * internal iteration.
     *
     * @param yield
     */
    @Override
    public void traverse(IntYield yield) {
        for (int i = prev; true; i = f.applyAsInt(i)) {
            yield.ret(i);
        }
    }

    @Override
    public boolean tryAdvance(IntYield yield) {
        int curr = prev;
        prev = f.applyAsInt(prev);
        yield.ret(curr);
        return true;
    }
}
