package org.xbib.event.async.yield.primitives.intgr.ops;

import org.xbib.event.async.yield.primitives.intgr.IntAdvancer;
import org.xbib.event.async.yield.primitives.intgr.IntQuery;
import org.xbib.event.async.yield.primitives.intgr.IntTraverser;
import org.xbib.event.async.yield.primitives.intgr.IntYield;

public class IntLimit implements IntAdvancer, IntTraverser {
    private final IntQuery upstream;
    private final int n;
    int count;

    public IntLimit(IntQuery upstream, int n) {
        this.upstream = upstream;
        this.n = n;
        count = 0;
    }

    @Override
    public void traverse(IntYield yield) {
        if (count >= n)
            throw new IllegalStateException("Traverser has already been operated on or closed!");
        while (this.tryAdvance(yield)) {
            // Intentionally empty. Action specified on yield statement of tryAdvance().
        }
    }

    @Override
    public boolean tryAdvance(IntYield yield) {
        if (count >= n) return false;
        count++;
        return upstream.tryAdvance(yield);
    }
}
