package org.xbib.event.async.yield.primitives.lng.ops;

import org.xbib.event.async.yield.boxes.BoolBox;
import org.xbib.event.async.yield.primitives.lng.LongAdvancer;
import org.xbib.event.async.yield.primitives.lng.LongQuery;
import org.xbib.event.async.yield.primitives.lng.LongTraverser;
import org.xbib.event.async.yield.primitives.lng.LongYield;

import java.util.HashSet;

public class LongDistinct implements LongAdvancer, LongTraverser {
    final HashSet<Long> mem = new HashSet<>();
    private final LongQuery upstream;

    public LongDistinct(LongQuery adv) {
        this.upstream = adv;
    }

    @Override
    public void traverse(LongYield yield) {
        upstream.traverse(item -> {
            if (mem.add(item)) {
                yield.ret(item);
            }
        });
    }

    @Override
    public boolean tryAdvance(LongYield yield) {
        final BoolBox found = new BoolBox();
        while (found.isFalse() && upstream.tryAdvance(item -> {
            if (mem.add(item)) {
                yield.ret(item);
                found.set();
            }
        })) ;
        return found.isTrue();
    }
}
