package org.xbib.event.async.yield.primitives.lng.ops;

import org.xbib.event.async.yield.primitives.lng.LongAdvancer;
import org.xbib.event.async.yield.primitives.lng.LongTraverser;
import org.xbib.event.async.yield.primitives.lng.LongYield;

import java.util.function.LongUnaryOperator;

public class LongIterate implements LongAdvancer, LongTraverser {
    private final LongUnaryOperator f;
    private long prev;

    public LongIterate(long seed, LongUnaryOperator f) {
        this.f = f;
        this.prev = seed;
    }

    /**
     * Continues from the polong where tryAdvance or next left the
     * longernal iteration.
     *
     * @param yield
     */
    @Override
    public void traverse(LongYield yield) {
        for (long i = prev; true; i = f.applyAsLong(i)) {
            yield.ret(i);
        }
    }

    @Override
    public boolean tryAdvance(LongYield yield) {
        long curr = prev;
        prev = f.applyAsLong(prev);
        yield.ret(curr);
        return true;
    }
}
