package org.xbib.event.async.yield.primitives.lng.ops;

import org.xbib.event.async.yield.primitives.lng.LongAdvancer;
import org.xbib.event.async.yield.primitives.lng.LongQuery;
import org.xbib.event.async.yield.primitives.lng.LongTraverser;
import org.xbib.event.async.yield.primitives.lng.LongYield;

public class LongLimit implements LongAdvancer, LongTraverser {
    private final LongQuery upstream;
    private final int n;
    int count;

    public LongLimit(LongQuery upstream, int n) {
        this.upstream = upstream;
        this.n = n;
        count = 0;
    }

    @Override
    public void traverse(LongYield yield) {
        if (count >= n)
            throw new IllegalStateException("Traverser has already been operated on or closed!");
        while (this.tryAdvance(yield)) {
            // Intentionally empty. Action specified on yield statement of tryAdvance().
        }
    }

    @Override
    public boolean tryAdvance(LongYield yield) {
        if (count >= n) return false;
        count++;
        return upstream.tryAdvance(yield);
    }
}
