package org.xbib.event.async.yield.primitives.lng.ops;

import org.xbib.event.async.yield.Advancer;
import org.xbib.event.async.yield.Traverser;
import org.xbib.event.async.yield.Yield;
import org.xbib.event.async.yield.primitives.lng.LongQuery;

import java.util.function.LongFunction;

public class LongMapToObj<T> implements Advancer<T>, Traverser<T> {

    private final LongQuery upstream;
    private final LongFunction<? extends T> mapper;

    public LongMapToObj(LongQuery adv, LongFunction<? extends T> mapper) {
        this.upstream = adv;
        this.mapper = mapper;
    }

    @Override
    public void traverse(Yield<? super T> yield) {
        upstream.traverse(e -> yield.ret(mapper.apply(e)));
    }

    @Override
    public boolean tryAdvance(Yield<? super T> yield) {
        return upstream.tryAdvance(item -> yield.ret(mapper.apply(item)));
    }
}
