package org.xbib.event.async.yield.primitives.lng.ops;

import org.xbib.event.async.yield.primitives.lng.LongAdvancer;
import org.xbib.event.async.yield.primitives.lng.LongQuery;
import org.xbib.event.async.yield.primitives.lng.LongTraverser;
import org.xbib.event.async.yield.primitives.lng.LongYield;

import java.util.function.LongConsumer;

public class LongPeek implements LongAdvancer, LongTraverser {
    private final LongQuery upstream;
    private final LongConsumer action;

    public LongPeek(LongQuery adv, LongConsumer action) {
        this.upstream = adv;
        this.action = action;
    }

    @Override
    public void traverse(LongYield yield) {
        upstream.traverse(item -> {
            action.accept(item);
            yield.ret(item);
        });
    }

    @Override
    public boolean tryAdvance(LongYield yield) {
        return upstream.tryAdvance(item -> {
            action.accept(item);
            yield.ret(item);
        });
    }
}
