package org.xbib.event.common;

import org.xbib.datastructures.json.tiny.Json;
import org.xbib.event.Event;

import java.io.IOException;
import java.util.Map;

public class EventImpl implements Event {

    private String type;

    private Map<String, Object> map;

    public EventImpl() {
    }

    @Override
    public void setType(String type) {
        this.type = type;
    }

    @Override
    public String getType() {
        return type;
    }

    @Override
    public void setMap(Map<String, Object> map) {
        this.map = map;
    }

    @Override
    public Map<String, Object> getMap() {
        return map;
    }

    public static EventImpl fromJson(String json) {
        Map<String, Object> map = Json.toMap(json);
        EventImpl event = new EventImpl();
        event.setType((String) map.get("type"));
        event.setMap(map);
        return event;
    }

    public String toJson() throws IOException {
        return Json.toString(map);
    }

    public boolean isNullEvent() {
        return type == null;
    }
}
