package org.xbib.event.log;

import java.io.IOException;
import java.io.Writer;

public class CharCountingWriter extends Writer {

    private final Writer writer;

    private long size;

    public CharCountingWriter(Writer writer, long size) {
        this.writer = writer;
        this.size = size;
    }

    public long size() {
        return size;
    }

    @Override
    public void write(int b) throws IOException {
        writer.write(b);
        size++;
    }

    @Override
    public void write(char[] cbuf, int off, int len) throws IOException {
        writer.write(cbuf, off, len);
        size += len;
    }

    @Override
    public void flush() throws IOException {
        writer.flush();
    }

    @Override
    public void close() throws IOException {
        writer.close();
    }
}
