package org.xbib.event.path;

import org.xbib.event.common.EventImpl;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.StandardCopyOption;
import java.nio.file.attribute.FileTime;
import java.time.Instant;

public class PathEventImpl extends EventImpl implements PathEvent {

    private Path path;

    private Path file;

    private String suffix;

    @Override
    public void setPath(Path path) {
        this.path = path;
    }

    @Override
    public Path getPath() {
        return path;
    }

    @Override
    public void setFile(Path file) {
        this.file = file;
    }

    @Override
    public Path getFile() {
        return file;
    }

    @Override
    public void setSuffix(String suffix) {
        this.suffix = suffix;
    }

    @Override
    public String getSuffix() {
        return suffix;
    }

    public void success() throws IOException {
        Files.setLastModifiedTime(file, FileTime.from(Instant.now()));
        Files.move(file, path.resolve(PathEventService.SUCCESS).resolve(file.getFileName()).toAbsolutePath(),
                StandardCopyOption.REPLACE_EXISTING);
    }

    public void fail() throws IOException {
        Files.setLastModifiedTime(file, FileTime.from(Instant.now()));
        Files.move(file, path.resolve(PathEventService.FAIL).resolve(file.getFileName()).toAbsolutePath(),
                StandardCopyOption.REPLACE_EXISTING);
    }

    @Override
    public String toString() {
        return "path=" + path + " file=" + file + " suffix=" + suffix + " map=" + getMap();
    }
}
