package org.xbib.event.clock;

import org.junit.jupiter.api.Test;
import org.xbib.event.common.EventManager;
import org.xbib.settings.Settings;

import java.io.IOException;

public class ClockEventManagerTest {

    @Test
    public void testEvents() throws IOException, InterruptedException {
        TestClockEventConsumer clockEventConsumer = new TestClockEventConsumer();
        Settings settings = Settings.settingsBuilder()
                .put("event.clock.testclockevent.enabled", "true")
                .put("event.clock.testclockevent.class", "org.xbib.event.clock.TestClockEvent")
                .put("event.clock.testclockevent.entry", "*/1 6-21 * * *")
                .build();
        EventManager eventManager = EventManager.builder(settings)
                .register(clockEventConsumer)
                .build();
        Thread.sleep(90000L);
        eventManager.close();
    }
}
