package org.xbib.event.loop;

public interface Promise<V> extends Future<V> {
    Promise<V> setSuccess(V value);

    boolean trySuccess(V value);

    Promise<V> setFailure(Throwable value);

    boolean tryFailure(Throwable value);

    boolean setUncancellable();

    Promise<V> addListener(GenericFutureListener<? extends Future<? super V>> value);

    @SuppressWarnings("unchecked")
    Promise<V> addListeners(GenericFutureListener<? extends Future<? super V>>... value);

    Promise<V> removeListener(GenericFutureListener<? extends Future<? super V>> value);

    @SuppressWarnings("unchecked")
    Promise<V> removeListeners(GenericFutureListener<? extends Future<? super V>>... value);

    Promise<V> await() throws InterruptedException;

    Promise<V> awaitUninterruptibly();

    Promise<V> sync() throws InterruptedException;

    Promise<V> syncUninterruptibly();
}
